class Public::AppearanceReleasesController < Public::BaseController
  include CreateReleasableJobs
  before_action :set_account, :set_project, :set_contract_template

  def new
    @appearance_release = build_appearance_release
  end

  def create
    @appearance_release = build_appearance_release(appearance_release_params_with_locale_and_contract_template)

    if @appearance_release.save(context: :native)
      log_create_analytics
      after_create(@appearance_release)
    else
      render :new
    end
  end

  private

  def set_project
    @project = @account.projects.find(params[:project_id])
  end

  def set_account
    @account = Account.find_by(slug: params[:account_id])
  end

  def set_contract_template
    @contract_template = @project.contract_templates.find(params[:contract_template_id])
  end

  def appearance_releases
    policy_scope(@project.appearance_releases)
  end

  def build_appearance_release(params = {})
    authorize appearance_releases.build(params)
  end

  def person_params
    %i[
      person_first_name
      person_last_name
      person_phone
      person_email
      person_photo
      person_address_street1
      person_address_street2
      person_address_city
      person_address_state
      person_address_zip
      person_address_country
    ]
  end

  def appearance_release_params
    params.require(:appearance_release).permit(person_params,
                                               :guardian_address, :guardian_first_name, :guardian_last_name, :guardian_phone, :guardian_email, :guardian_photo, :minor,
                                               :signature_base64, :person_date_of_birth,
                                               :locale, :contract_template,)
  end

  def appearance_release_params_with_locale
    appearance_release_params.merge(locale: I18n.locale)
  end

  def appearance_release_params_with_locale_and_contract_template
    appearance_release_params_with_locale.merge(contract_template: @contract_template)
  end

  def log_create_analytics
    TrackAnalyticsJob.perform_later(nil, nil, :track_create_native_release, release_type: AppearanceRelease.to_s, account: @account, user_agent: request.user_agent, user_ip: request.remote_ip)
  end
end
